// (C) 2003 by Jeremy Stanley
// This program is licensed under the GNU General Public License.
// See COPYING for details.

// implementation of ang.c

#include "fix.h"
#include "ang.h"
#include <graph.h>
#include <timath.h>
#include <stdlib.h>

FIX *cos_t = NULL, *tan_t = NULL, *cot_t = NULL;

short ang_initialize(void *tab_start)
{
   short i;
   float t;
#if ANG_90 == 144
   // initialize progress bar variables
   short r;
   unsigned char *st = (unsigned char *)LCD_MEM + 94 * 30, *sr, mask = 0xFF;
#endif
   float ang = 0, da = 3.14159265359f / ANG_180;

   cos_t = tab_start;
   tan_t = cos_t + TABSIZE;
   cot_t = tan_t + TABSIZE;

   for(i = 0; i <= ANG_90; i++)
   {
	    cos_t[i] = FLT_TO_FIX(cos(ang));  

      t = tan(ang);
	    tan_t[i] = FLT_TO_FIX(t);
  	  cot_t[i] = FLT_TO_FIX(1.0f / t);

#if ANG_90 == 144
      // add 8 units to the progress bar for each 8 angles computed
      if((i & 7) == 7) 
      {
      	  if(i > 136) mask = 0xE0;	// prevent partially overwriting "BUSY" indicator
          sr = st;
       	  for(r = 0; r < 6; r++)
      	  {
             *sr ^= mask;
             sr += 30;      	  	 
      	  }
      	  st++;
      }
#endif
  	  
  	  ang += da;
   }

   return 1;
}

void ang_cleanup()
{
   free(cos_t);
}

// compute sines and cosines within [0...ANG_360)
// (cos_t and sec_t store only [0...ANG_90); sines are not stored at all.)
// these functions all assume that ang is in the range [0...ANG_360)

FIX sin_f(short ang)
{
   if (ang <= ANG_90)
      return cos_t[ANG_Q1 - ang];
   else if (ang <= ANG_180)
      return cos_t[ang - ANG_90];
   else if (ang <= ANG_270)
      return -cos_t[ANG_Q3 - ang];
   else
      return -cos_t[ang - ANG_270];
}

FIX cos_f(short ang)
{
   if (ang <= ANG_90)
      return cos_t[ang];
   else if (ang <= ANG_180)
      return -cos_t[ANG_Q2 - ang];
   else if (ang <= ANG_270)
      return -cos_t[ang - ANG_180];
   else
      return cos_t[ANG_Q4 - ang];
}

/*
FIX sec_f(short ang)
{
   if (ang < ANG_90)
      return sec_t[ang];
   else if (ang < ANG_180)
      return -sec_t[ANG_Q2 - ang];
   else if (ang < ANG_270)
      return -sec_t[ang - ANG_180];
   else
      return sec_t[ANG_Q4 - ang];
}

FIX tan_f(short ang)
{
	if (ang >= ANG_180)
		ang -= ANG_180;

	if (ang < ANG_90)
		return tan_t[ang];
	else
		return -tan_t[ANG_180 - ang - 1];
}

FIX cot_f(short ang)
{
	if (ang >= ANG_180)
		ang -= ANG_180;

	if (ang < ANG_90)
		return tan_recip_t[ang];
	else
		return -tan_recip_t[ANG_180 - ang - 1];
}
*/
