// ang.h -- trig tables for amazing
// (C) 2003 by Jeremy Stanley

// This program is licensed under the GNU General Public License.
// See COPYING for details.

#ifndef ANG_H
#define ANG_H

#include "fix.h"

#define FOV 60  // player's field of vision
#define WID 96  // width of the playing field (i.e., number of rays cast)
#define HEI 96	// height of playing field
#define REFHEIGHT INT_TO_FIX(HEI/2)
#define ANG_0    0
#define ANG_90   ((90 * WID) / FOV)
#define ANG_180  (2 * ANG_90)
#define ANG_270  (3 * ANG_90)
#define ANG_360  (4 * ANG_90)
#define ANG_Q1   ANG_90 
#define ANG_Q2   ANG_180
#define ANG_Q3   ANG_270
#define ANG_Q4   ANG_360

#define BUFPITCH (WID / 8)
#define BUFSIZE  (BUFPITCH * HEI)

#define TABSIZE (ANG_90 + 1)
#define TOTSIZE (3 * TABSIZE * sizeof(FIX))

extern FIX *cos_t, *tan_t, *cot_t;
short ang_initialize(void *tab_start);
void ang_cleanup();

// compute angles outside the first quadrant
FIX sin_f(short ang);
FIX cos_f(short ang);

/* not needed since this functions are used in the first quadrant only
FIX tan_f(short ang);
FIX cot_f(short ang);
*/

#endif // ANG_H
