// fix.h -- fixed-point math macros
// (C) 2003 by Jeremy Stanley

// This program is licensed under the GNU General Public License.
// See COPYING for details.

#ifndef FIX_H
#define FIX_H

typedef signed long FIX;


/*
// 16-16
#define FIX_1         0x00010000L
#define FLT_TO_FIX(n)	((FIX)(65536.0f*(n)))
#define FIX_TO_FLT(n)	(((float)(n))/65536.0f)
#define INT_TO_FIX(n)	(((FIX)(n))<<16)
#define FIX_TO_INT(n)	((int)((n)>>16))
#define FIX_MUL(a,b)	((((a)>>5)*((b)>>5))>>6)
#define FIX_DIV(a,b)	((((a)<<5)/((b)>>5))<<6)
#define FIX_FPART(x)  ((x) & 0xFFFFL)
#define FIX_IPART(x)  ((x) & 0xFFFF0000L)
#define FIX_MUL(a,b)	((((a)>>5)*((b)>>5))>>6)
#define FIX_DIV(a,b)	((((a)<<5)/((b)>>5))<<6)
*/

// 14-18
#define FRAC_PREC     18L
#define FIX_1         (1L << FRAC_PREC)
#define FLT_TO_FIX(n)	((FIX)((float)FIX_1 * (n)))
#define FIX_TO_FLT(n)	(((float)(n))/(float)FIX_1)
#define INT_TO_FIX(n)	(((FIX)(n))<<FRAC_PREC)
#define FIX_TO_INT(n)	((int)((n)>>FRAC_PREC))
#define FIX_FMASK     (FIX_1 - 1)
#define FIX_IMASK     (~FIX_FMASK)
#define FIX_FPART(x)  ((x) & FIX_FMASK)
#define FIX_IPART(x)  ((x) & FIX_IMASK)
#define FIX_MUL(a,b)	((((a)>>6)*((b)>>6))>>6)
#define FIX_DIV(a,b)	((((a)<<6)/((b)>>6))<<6)

/* -- the "short" option really didn't pan out --

// fixed-point options
typedef short FIX;
#define FRAC_PREC  ((FIX)8)

typedef float FLT;
typedef short F_INT;

// conversion macros
#define FIX_1 ((FIX)(1 << FRAC_PREC))
#define FLT_TO_FIX(x) ((FIX)((x) * FIX_1))
#define INT_TO_FIX(x) ((FIX)((x) << FRAC_PREC))
#define FIX_TO_INT(x) ((F_INT)((x) >> FRAC_PREC))
#define FIX_TO_FLT(x) ((FLT)((x) / (FLT)FIX_1))
#define FIX_FMASK    ((FIX)(FIX_1 - 1))
#define FIX_IMASK    ((FIX)(~FIX_FMASK))
#define FIX_FPART(x) ((FIX)((x) & FIX_FMASK))
#define FIX_IPART(x) ((FIX)((x) & FIX_IMASK))

// fixed-point math
// (addition and subtraction among FIXes work using integer operators)
//#define FIX_MUL(x, y) (((x) * (y)) >> FRAC_PREC)
#define FIX_MUL(x, y) ((FIX)(((long)(x) * (y)) >> FRAC_PREC))
#define FIX_DIV(x, y) ((FIX)(((long)(x) << FRAC_PREC) / (y)))
*/

#endif // FIX_H

