// (C) 2003 by Jeremy Stanley
// This program is licensed under the GNU General Public License.
// See COPYING for details.

#include "graphics.h"
#include "ang.h"
 
void pixelcol89(short col, short top, short h, void *buf, short pitch)
{
	unsigned char *p = (unsigned char *)buf + pitch * top + (col >> 3);
	unsigned char mask = (unsigned char)0x80 >> (col & 7);
	short i;

	for(i = 0; i < h; i++)
	{
		*p |= mask;
		p += pitch;
	}
}

/* gray column--not used (the calc lcd doesn't like displaying that pattern)
void pixelcol89g(short col, short top, short h, void *buf)
{
	unsigned char *p, mask;
	short i;
	
	if((col ^ top) & 1) top++;
	p = (unsigned char *)buf + BUFPITCH * top + (col >> 3);
	mask = (unsigned char)0x80 >> (col & 7);

	h >>= 1; 

	for(i = 0; i < h; i++)
	{
		*p |= mask;
		p += BUFPITCH + BUFPITCH;
	}
}
*/

#ifdef TEXTURE_WALLS

void texturecol(short col, short top, short h, short tx, short th, void *buf, void *stonetex)
{
		if (h < 2) return;	// else den = 0 and we have an infinite loop

    short v = ((th==h) ? 0 : ((th - h) << 6) / (th << 1));
    short tex_h = 64 - (v << 1);
    short i;

	  unsigned char *pixloc = (unsigned char *)buf + BUFPITCH * top + (col >> 3);
  	unsigned char pmask = (unsigned char)0x80 >> (col & 7);
  	unsigned char imask = ~pmask;

    unsigned short *pTex = (unsigned short *)stonetex + (tx << 2) + (v >> 4);
    unsigned short tmask = (unsigned short)0x8000 >> (v & 15);
    unsigned short ts_l = *pTex, ts_d = *(pTex + 512);

    short num = tex_h-1, den = h-1;
    short inc = den;
   
    for(i = 0; i < h; i++)
    {
        // Write a pixel and advance the screen pointer
				// light plane
        if(ts_l & tmask)
            *pixloc |= pmask;
        else
        		*pixloc &= imask;
        		
        // dark plane
        if(ts_d & tmask)
        		*(pixloc + BUFSIZE) |= pmask;
        else
        		*(pixloc + BUFSIZE) &= imask;
        		
        pixloc += BUFPITCH;

        // Advance the texture pointer if needed
        inc += num;
        while(inc > den)
        {
            tmask >>= 1;
            if(!tmask) {
            	tmask = (unsigned short)0x8000;
            	pTex++;
            	ts_l = *pTex;
            	ts_d = *(pTex + 512);
            }
            inc -= den;
        }
    }
}

#endif
